/**
 * generated by Xtext 2.19.0
 */
package fr.istic.mML.impl;

import fr.istic.mML.LinearRegression;
import fr.istic.mML.MMLPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Linear Regression</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link fr.istic.mML.impl.LinearRegressionImpl#getLinearRegression <em>Linear Regression</em>}</li>
 * </ul>
 *
 * @generated
 */
public class LinearRegressionImpl extends MLAlgorithmImpl implements LinearRegression
{
  /**
   * The default value of the '{@link #getLinearRegression() <em>Linear Regression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLinearRegression()
   * @generated
   * @ordered
   */
  protected static final String LINEAR_REGRESSION_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getLinearRegression() <em>Linear Regression</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLinearRegression()
   * @generated
   * @ordered
   */
  protected String linearRegression = LINEAR_REGRESSION_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected LinearRegressionImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return MMLPackage.Literals.LINEAR_REGRESSION;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getLinearRegression()
  {
    return linearRegression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setLinearRegression(String newLinearRegression)
  {
    String oldLinearRegression = linearRegression;
    linearRegression = newLinearRegression;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, MMLPackage.LINEAR_REGRESSION__LINEAR_REGRESSION, oldLinearRegression, linearRegression));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case MMLPackage.LINEAR_REGRESSION__LINEAR_REGRESSION:
        return getLinearRegression();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case MMLPackage.LINEAR_REGRESSION__LINEAR_REGRESSION:
        setLinearRegression((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case MMLPackage.LINEAR_REGRESSION__LINEAR_REGRESSION:
        setLinearRegression(LINEAR_REGRESSION_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case MMLPackage.LINEAR_REGRESSION__LINEAR_REGRESSION:
        return LINEAR_REGRESSION_EDEFAULT == null ? linearRegression != null : !LINEAR_REGRESSION_EDEFAULT.equals(linearRegression);
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuilder result = new StringBuilder(super.toString());
    result.append(" (linearRegression: ");
    result.append(linearRegression);
    result.append(')');
    return result.toString();
  }

} //LinearRegressionImpl
